//Problema 5_6
clear;
clc;

//--------------------------------------
// Modelado de la planta discreta

s=%s;
num2=23;
den2=(s)*(s+114);
GH=syslin('c',num2/den2);
Ts=0.01;

GHD=dscr(GH,Ts);
z=%z;              // Agrego el retardo de una muestra
GHD=(1/z)*GHD;
zpk(GHD)
GHZ=ss2tf(GHD);
[z,p,k]=ss2zp(GHD);

KP=k;
ZZ0=z(1,1);
ZP1=p(1,1);
ZP2=p(2,1);
ZP3=p(3,1);

//--------------------------------------
// Calculo de DZ [DEAD-BEAT]

NUMTZ=[1];
DENTZ=[%z^2];
TZ=syslin("d",NUMTZ,DENTZ);
zpk(TZ)

DZ=(1/GHZ)*(TZ/(1-TZ));
zpk(DZ);
[zd,pd,kd]=tf2zp(DZ);

KDB=kd;
ZDZ0=zd(1,1);
ZDZ1=zd(2,1);
ZDP1=pd(1,1);
ZDP2=pd(2,1);

//--------------------------------------
// Calculo de DZ [DAHLIN]
tau=0.05;
landa=1/tau;
q=exp(-landa*Ts);

NUMTZ2=[1-q];
DENTZ2=[%z^2-q*%z];
TZ2=syslin("d",NUMTZ2,DENTZ2);

DZ2=(1/GHZ)*(TZ2/(1-TZ2));
zpk(DZ2)
[zd2,pd2,kd2]=tf2zp(DZ2);

KDH=kd2;
ZDZ0H=zd2(1,1);
ZDZ1H=zd2(2,1);
ZDP1H=pd2(1,1);
ZDP2H=pd2(2,1);

